local isConfiguring = false;

BINDING_HEADER_MALOWRUNEOFPOWER = "MaloWRuneOfPower";
SLASH_MALOWRUNEOFPOWER1 = "/mrop";
SLASH_MALOWRUNEOFPOWER2 = "/malowruneofpower";
local function MaloWRuneOfPower_SlashHandler(msg, editbox)
	if msg == "" or msg == nil then
		MaloWRuneOfPower_PrintMenu();
	end
	if msg == "lock" then
		if MaloWRuneOfPowerSVLocked == true then
      MaloWRuneOfPowerFrame:SetMovable(true);
      MaloWRuneOfPowerFrame:EnableMouse(true);
      MaloWRuneOfPowerSVLocked = false;
      print("MaloWRuneOfPower is now unlocked, type /mrop lock again to lock it.");
    else
      MaloWRuneOfPowerFrame:SetMovable(false);
      MaloWRuneOfPowerFrame:EnableMouse(false);
      MaloWRuneOfPowerSVLocked = true;
      print("MaloWRuneOfPower is now locked, type /mrop lock again to unlock it.");
    end
	end
	if msg == "combat" then
		
	end
	if msg == "resetpos" then
		MaloWRuneOfPowerFrame:SetPoint("TOPLEFT", nil, "TOPLEFT", 400, -400);
    print("MaloWRuneOfPower position has now been reset.");
	end
	if msg == "show" then
		MaloWRuneOfPowerFrame:Show();
		isConfiguring = true;
		print("MaloWRuneOfPower is now being shown for configuration, type '/mrop hide' to hide it when you're done");
	end
	if msg == "hide" then
		MaloWRuneOfPowerFrame:Hide();
		isConfiguring = false;
		print("MaloWRuneOfPower is now hidden, it will automatically show when you're in combat");
	end
	if string.match(msg, "scale") then
		local scale = string.sub(msg, 7);
		MaloWRuneOfPowerFrame:SetScale(scale);
		MaloWRuneOfPowerSVScale = scale;
	end
end 
SlashCmdList["MALOWRUNEOFPOWER"] = MaloWRuneOfPower_SlashHandler;

function MaloWRuneOfPower_PrintMenu()
	print("MaloWRuneOfPower: Arguments to /mif :");
	print("scale - Scales the frame. Default 1.0");
	print("lock - Toggles the frame being locked from movement");
	--print("combat - Toggles if the frame will hide when you leave combat");
	print("show - Shows the frame so you can configure it. Type '/mrop hide' when you're done");
	print("hide - Hides the frames");
	print("resetpos - Resets the position of the frame");
	
end

local startedCast = false;
local firstIsNextCast = true;
local ROP1Time = 0;
local ROP2Time = 0;
local previousUpdateTime = 0;

function MaloWRuneOfPower_OnEvent(self, event, arg1, arg2, ...)
	if event == "ADDON_LOADED" and arg1 == "MaloWRuneOfPower" then
		if MaloWRuneOfPowerSVScale == nil then
			MaloWRuneOfPowerSVScale = 1.0;
		else
			MaloWRuneOfPowerFrame:SetScale(MaloWRuneOfPowerSVScale);
		end
    if MaloWRuneOfPowerSVPositionX == nil or MaloWRuneOfPowerSVPositionY == nil or MaloWRuneOfPowerSVPositionPoint == nil then
      MaloWRuneOfPowerSVPositionX = 0;
      MMaloWRuneOfPowerSVPositionY = 0;
      MaloWRuneOfPowerSVPositionPoint = "CENTER";
    else
      MaloWRuneOfPowerFrame:SetPoint(MaloWRuneOfPowerSVPositionPoint, nil, MaloWRuneOfPowerSVPositionPoint, MaloWRuneOfPowerSVPositionX, MaloWRuneOfPowerSVPositionY);
    end
		if MaloWRuneOfPowerSVLocked == nil or MaloWRuneOfPowerSVLocked == false then
      MaloWRuneOfPowerFrame:SetMovable(true);
      MaloWRuneOfPowerFrame:EnableMouse(true);
			MaloWRuneOfPowerSVLocked = false;
    else
      MaloWRuneOfPowerFrame:SetMovable(false); 
      MaloWRuneOfPowerFrame:EnableMouse(false);
		end
	elseif event == "UNIT_AURA" then
    if arg1 == "player" then
      MaloWRuneOfPower_Update();
    end
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		if arg1 == "player" and arg2 == "Rune of Power" then
			if startedCast == true then
				startedCast = false;
				MaloWRuneOfPower_OnRuneOfPowerCast();
			end
		end
	elseif event == "UNIT_SPELLCAST_START" then
		if arg1 == "player" and arg2 == "Rune of Power" then
			startedCast = true;
		end
	end
end 

function MaloWRuneOfPower_OnUpdate(self, elapsed)
  if GetTime() < previousUpdateTime + 0.1 then
    return;
  end
  previousUpdateTime = GetTime();
	MaloWRuneOfPower_Update();
end

function MaloWRuneOfPower_OnRuneOfPowerCast()
	if firstIsNextCast == true then
		ROP1Time = GetTime();
		firstIsNextCast = false;
	else
		ROP2Time = GetTime();
		firstIsNextCast = true;
	end
	MaloWRuneOfPower_Update();
end

function MaloWRuneOfPower_OnStopDragging()
  local point, relativeTo, relativePoint, xOfs, yOfs = MaloWRuneOfPowerFrame:GetPoint();
  MaloWRuneOfPowerSVPositionX = xOfs;
  MaloWRuneOfPowerSVPositionY = yOfs;
  MaloWRuneOfPowerSVPositionPoint = point;
end

function MaloWRuneOfPower_Update()
	if (UnitAffectingCombat("player") == false or MaloWRuneOfPower_HasRuneOfPowerSpecced() == false) and isConfiguring == false then
		MaloWRuneOfPowerFrame:Hide();
		return;
	end
	MaloWRuneOfPowerFrame:Show();
	
	-- Hide texts if RoP hasnt been casted yet.
	if ROP1Time == 0 then
		MaloWRuneOfPowerFrameROP1Text:Hide();
	else
		MaloWRuneOfPowerFrameROP1Text:Show();
	end
	if ROP2Time == 0 then
		MaloWRuneOfPowerFrameROP2Text:Hide();
	else
		MaloWRuneOfPowerFrameROP2Text:Show();
	end
	
	ROP1TimeLeft = 180 - (GetTime() - ROP1Time);
	ROP2TimeLeft = 180 - (GetTime() - ROP2Time);
	
	if ROP1TimeLeft < 0 then
		ROP1TimeLeft = 0;
		MaloWRuneOfPowerFrameROP1Background:SetTexture(1.0, 0.0, 0.0, 1.0);
	elseif ROP1TimeLeft < 10 then
		MaloWRuneOfPowerFrameROP1Background:SetTexture(1.0, 1.0, 0.0, 1.0);
	else
		MaloWRuneOfPowerFrameROP1Background:SetTexture(0.1, 0.1, 0.15, 1.0);
	end
	
	if ROP2TimeLeft < 0 then
		ROP2TimeLeft = 0;
		MaloWRuneOfPowerFrameROP2Background:SetTexture(1.0, 0.0, 0.0, 1.0);
	elseif ROP2TimeLeft < 10 then
		MaloWRuneOfPowerFrameROP2Background:SetTexture(1.0, 1.0, 0.0, 1.0);
	else
		MaloWRuneOfPowerFrameROP2Background:SetTexture(0.1, 0.1, 0.15, 1.0);
	end
	
	ROP1TimeLeftMinutes = math.floor(ROP1TimeLeft / 60);
	ROP2TimeLeftMinutes = math.floor(ROP2TimeLeft / 60);
	
	ROP1TimeLeftSeconds = math.floor(ROP1TimeLeft - (ROP1TimeLeftMinutes * 60));
	ROP2TimeLeftSeconds = math.floor(ROP2TimeLeft - (ROP2TimeLeftMinutes * 60));
	
	if ROP1TimeLeftSeconds < 10 then
		ROP1TimeLeftSeconds = "0" .. ROP1TimeLeftSeconds;
	end
	if ROP2TimeLeftSeconds < 10 then
		ROP2TimeLeftSeconds = "0" .. ROP2TimeLeftSeconds;
	end
	
	MaloWRuneOfPowerFrameROP1Text:SetText(ROP1TimeLeftMinutes .. ":" .. ROP1TimeLeftSeconds);
	MaloWRuneOfPowerFrameROP2Text:SetText(ROP2TimeLeftMinutes .. ":" .. ROP2TimeLeftSeconds);
	
	if MaloWRuneOfPower_HasRuneOfPowerBuff() == false then
		--MaloWRuneOfPowerFrame:SetHeight(63);
		MaloWRuneOfPowerFrameBigIconFrame:Show();
	else
		--MaloWRuneOfPowerFrame:SetHeight(25);
		MaloWRuneOfPowerFrameBigIconFrame:Hide();
	end
end

function MaloWRuneOfPower_HasRuneOfPowerBuff()
	for i = 1, 40 do 
		local name = UnitBuff("player",i); 
		if name == "Rune of Power" then 
			return true;
		end 
	end
	return false;
end

function MaloWRuneOfPower_HasRuneOfPowerSpecced()
	local isFree, talent = GetTalentRowSelectionInfo(6);
	if talent == 16032 then
		return true;
	else
		return false;
	end
end